# Create an AI model config

POST https://app.launchdarkly.com/api/v2/projects/{projectKey}/ai-configs/model-configs
Content-Type: application/json

Create an AI model config. You can use this in any variation for any AI Config in your project.

Reference: https://launchdarkly.com/docs/api/ai-configs/post-model-config

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: LaunchDarkly REST API
  version: 1.0.0
paths:
  /api/v2/projects/{projectKey}/ai-configs/model-configs:
    post:
      operationId: post-model-config
      summary: Create an AI model config
      description: >-
        Create an AI model config. You can use this in any variation for any AI
        Config in your project.
      tags:
        - subpackage_aiConfigs
      parameters:
        - name: projectKey
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ModelConfig'
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '404':
          description: Not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
      requestBody:
        description: AI model config object to create
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ModelConfigPost'
servers:
  - url: https://app.launchdarkly.com
  - url: https://app.launchdarkly.us
components:
  schemas:
    ModelConfigPostParams:
      type: object
      properties: {}
      title: ModelConfigPostParams
    ModelConfigPostCustomParams:
      type: object
      properties: {}
      title: ModelConfigPostCustomParams
    ModelConfigPost:
      type: object
      properties:
        name:
          type: string
          description: Human readable name of the model
        key:
          type: string
          description: Unique key for the model
        id:
          type: string
          description: Identifier for the model, for use with third party providers
        icon:
          type: string
          description: Icon for the model
        provider:
          type: string
          description: Provider for the model
        params:
          $ref: '#/components/schemas/ModelConfigPostParams'
        customParams:
          $ref: '#/components/schemas/ModelConfigPostCustomParams'
        tags:
          type: array
          items:
            type: string
        costPerInputToken:
          type: number
          format: double
          description: Cost per input token in USD
        costPerOutputToken:
          type: number
          format: double
          description: Cost per output token in USD
      required:
        - name
        - key
        - id
      title: ModelConfigPost
    ActionSpecifier:
      type: string
      title: ActionSpecifier
    AiConfigsAccessDeniedReasonEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: AiConfigsAccessDeniedReasonEffect
    AiConfigsAccessDeniedReason:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> and <code>notActions</code> fields must be
            empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> and <code>notResources</code> fields must be
            empty to use this field.
        effect:
          $ref: '#/components/schemas/AiConfigsAccessDeniedReasonEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
        role_name:
          type: string
      required:
        - effect
      title: AiConfigsAccessDeniedReason
    AiConfigsAccessDenied:
      type: object
      properties:
        action:
          type: string
        reason:
          $ref: '#/components/schemas/AiConfigsAccessDeniedReason'
      required:
        - action
        - reason
      title: AiConfigsAccessDenied
    AiConfigsAccessAllowedReasonEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: AiConfigsAccessAllowedReasonEffect
    AiConfigsAccessAllowedReason:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> and <code>notActions</code> fields must be
            empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> and <code>notResources</code> fields must be
            empty to use this field.
        effect:
          $ref: '#/components/schemas/AiConfigsAccessAllowedReasonEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
        role_name:
          type: string
      required:
        - effect
      title: AiConfigsAccessAllowedReason
    AiConfigsAccessAllowedRep:
      type: object
      properties:
        action:
          type: string
        reason:
          $ref: '#/components/schemas/AiConfigsAccessAllowedReason'
      required:
        - action
        - reason
      title: AiConfigsAccessAllowedRep
    AiConfigsAccess:
      type: object
      properties:
        denied:
          type: array
          items:
            $ref: '#/components/schemas/AiConfigsAccessDenied'
        allowed:
          type: array
          items:
            $ref: '#/components/schemas/AiConfigsAccessAllowedRep'
      required:
        - denied
        - allowed
      title: AiConfigsAccess
    ModelConfigParams:
      type: object
      properties: {}
      title: ModelConfigParams
    ModelConfigCustomParams:
      type: object
      properties: {}
      title: ModelConfigCustomParams
    ModelConfig:
      type: object
      properties:
        _access:
          $ref: '#/components/schemas/AiConfigsAccess'
        name:
          type: string
          description: Human readable name of the model
        key:
          type: string
          description: Unique key for the model
        id:
          type: string
          description: Identifier for the model, for use with third party providers
        icon:
          type: string
          description: Icon for the model
        provider:
          type: string
          description: Provider for the model
        global:
          type: boolean
          description: Whether the model is global
        params:
          $ref: '#/components/schemas/ModelConfigParams'
        customParams:
          $ref: '#/components/schemas/ModelConfigCustomParams'
        tags:
          type: array
          items:
            type: string
        version:
          type: integer
        costPerInputToken:
          type: number
          format: double
          description: Cost per input token in USD
        costPerOutputToken:
          type: number
          format: double
          description: Cost per output token in USD
        isRestricted:
          type: boolean
          description: Whether the model is restricted
      required:
        - name
        - key
        - id
        - global
        - tags
        - version
        - isRestricted
      title: ModelConfig
    Error:
      type: object
      properties:
        message:
          type: string
        code:
          type: string
      required:
        - message
        - code
      title: Error
  securitySchemes:
    ApiKey:
      type: apiKey
      in: header
      name: Authorization

```

## SDK Code Examples

```python
import requests

url = "https://app.launchdarkly.com/api/v2/projects/default/ai-configs/model-configs"

payload = {
    "name": "name",
    "key": "key",
    "id": "id",
    "icon": "icon",
    "provider": "provider",
    "params": "{}",
    "customParams": "{}",
    "tags": ["tags", "tags"],
    "costPerInputToken": 0.8008281904610115,
    "costPerOutputToken": 6.027456183070403
}
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://app.launchdarkly.com/api/v2/projects/default/ai-configs/model-configs';
const options = {
  method: 'POST',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"name":"name","key":"key","id":"id","icon":"icon","provider":"provider","params":"{}","customParams":"{}","tags":["tags","tags"],"costPerInputToken":0.8008281904610115,"costPerOutputToken":6.027456183070403}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://app.launchdarkly.com/api/v2/projects/default/ai-configs/model-configs"

	payload := strings.NewReader("{\n  \"name\": \"name\",\n  \"key\": \"key\",\n  \"id\": \"id\",\n  \"icon\": \"icon\",\n  \"provider\": \"provider\",\n  \"params\": \"{}\",\n  \"customParams\": \"{}\",\n  \"tags\": [\n    \"tags\",\n    \"tags\"\n  ],\n  \"costPerInputToken\": 0.8008281904610115,\n  \"costPerOutputToken\": 6.027456183070403\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://app.launchdarkly.com/api/v2/projects/default/ai-configs/model-configs")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"name\",\n  \"key\": \"key\",\n  \"id\": \"id\",\n  \"icon\": \"icon\",\n  \"provider\": \"provider\",\n  \"params\": \"{}\",\n  \"customParams\": \"{}\",\n  \"tags\": [\n    \"tags\",\n    \"tags\"\n  ],\n  \"costPerInputToken\": 0.8008281904610115,\n  \"costPerOutputToken\": 6.027456183070403\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://app.launchdarkly.com/api/v2/projects/default/ai-configs/model-configs")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"name\",\n  \"key\": \"key\",\n  \"id\": \"id\",\n  \"icon\": \"icon\",\n  \"provider\": \"provider\",\n  \"params\": \"{}\",\n  \"customParams\": \"{}\",\n  \"tags\": [\n    \"tags\",\n    \"tags\"\n  ],\n  \"costPerInputToken\": 0.8008281904610115,\n  \"costPerOutputToken\": 6.027456183070403\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://app.launchdarkly.com/api/v2/projects/default/ai-configs/model-configs', [
  'body' => '{
  "name": "name",
  "key": "key",
  "id": "id",
  "icon": "icon",
  "provider": "provider",
  "params": "{}",
  "customParams": "{}",
  "tags": [
    "tags",
    "tags"
  ],
  "costPerInputToken": 0.8008281904610115,
  "costPerOutputToken": 6.027456183070403
}',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://app.launchdarkly.com/api/v2/projects/default/ai-configs/model-configs");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"name\",\n  \"key\": \"key\",\n  \"id\": \"id\",\n  \"icon\": \"icon\",\n  \"provider\": \"provider\",\n  \"params\": \"{}\",\n  \"customParams\": \"{}\",\n  \"tags\": [\n    \"tags\",\n    \"tags\"\n  ],\n  \"costPerInputToken\": 0.8008281904610115,\n  \"costPerOutputToken\": 6.027456183070403\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "name",
  "key": "key",
  "id": "id",
  "icon": "icon",
  "provider": "provider",
  "params": "{}",
  "customParams": "{}",
  "tags": ["tags", "tags"],
  "costPerInputToken": 0.8008281904610115,
  "costPerOutputToken": 6.027456183070403
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://app.launchdarkly.com/api/v2/projects/default/ai-configs/model-configs")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```